import os,sys

# Attach $SUMO_HOME/tools to the path to import SUMO libraries
if 'SUMO_HOME' in os.environ:
    sys.path.append(os.path.join(os.environ['SUMO_HOME'], 'tools'))
    import sumolib
    # import libsumo as traci
    import traci
    import traci.constants as tc
else:
    raise Exception("Please declare environment variable 'SUMO_HOME'")

sumo_parameters = ['sumo', '-c', './scenario/sumo.cfg.xml', '--log', 'log.txt']
traci.start(sumo_parameters)

step_counter = 0

while traci.simulation.getMinExpectedNumber() > 0:
    step_counter += 1
    print('STEP {}'.format(step_counter))

    print(traci.vehicle.getIDList())
    traci.simulation.subscribe(varIDs=[
        tc.VAR_COLLISIONS,
        tc.VAR_COLLIDING_VEHICLES_IDS,
        tc.VAR_COLLIDING_VEHICLES_NUMBER,
    ])

    if 'f.0' in traci.vehicle.getIDList():

        # traci.lane.subscribe('1f2_0',varIDs=[

        # ])
        traci.vehicletype.subscribe('veh', varIDs=[
            tc.VAR_ACCEL,
            tc.VAR_DECEL,
        ])
        traci.vehicle.subscribe('f.0', varIDs=[
            tc.VAR_SPEED,
            tc.VAR_ACCELERATION,
            tc.VAR_LANEPOSITION,
            tc.VAR_LANE_INDEX,
            tc.VAR_LANE_ID,
            tc.VAR_MAXSPEED,

            #### UNSOLVED (ubyte format error):
            # tc.LANECHANGE_LEFT,
            # tc.LANECHANGE_RIGHT,
            # tc.LANE_ALLOWED,
            # tc.LANE_CHANGES,
            # tc.LCA_WANTS_LANECHANGE,
            # tc.LCA_WANTS_LANECHANGE_OR_STAY,

            #### UNSOLVED (unknown domain):
            # tc.VAR_ALLOWED_SPEED,
            # tc.VAR_PREV_SPEED,


            ### SOLVED (different domain)
            # tc.VAR_COLLIDING_VEHICLES_IDS,
            # tc.VAR_COLLIDING_VEHICLES_NUMBER,
            # tc.VAR_COLLISIONS,
            # tc.VAR_ACCEL,
            # tc.VAR_DECEL,
        ])

    print('veh subs', traci.vehicle.getAllSubscriptionResults())
    print('sim subs', traci.simulation.getAllSubscriptionResults())
    print('vehicletype subs', traci.vehicletype.getAllSubscriptionResults())

    traci.simulationStep()
    input()

traci.close()